<template>
  <section-container title="Storage">
    <div class="row mb-3">
      <div class="col-12 col-sm-3">
        <button type="button" class="btn btn-success" @click="refreshStorage">
          <i class="fas fa-sync"></i> Refresh Storage
        </button>
      </div>
      <div class="col-12 col-sm-3">
        <input
          type="checkbox"
          name="public-only"
          id="public-only"
          class="form-check-input"
          v-model="publicOnly"
        />&nbsp;<label for="public-only">Only show standard kexes</label>
      </div>
    </div>
    <storage-tree :public="publicOnly" ref="storageTree" />
  </section-container>
</template>

<script>
import StorageTree from "@/components/StorageTree";

export default {
  components: { StorageTree },
  name: "Storage",
  data() {
    return {
      publicOnly: true,
    };
  },
  provide() {
    return {
      refreshStorage: this.refreshStorage,
      deleteKex: this.deleteKex,
      copyTable: this.copyTable,
      deleteTable: this.deleteTable,
      truncateTable: this.truncateTable,
      tableExists: this.tableExists,
      setTableMetadata: this.setTableMetadata,
    };
  },
  inject: ["toggleProgressSpinner"],
  methods: {
    reloadStorageView(kex, table) {
      this.$refs.storageTree.reloadStorageView(kex, table);
    },
    setTableMetadata(kex, table, metadata) {
      this.toggleProgressSpinner(true);
      const url = `${this.apiUrl}/storage/kex/${kex}/tables/${table}/metadata`;
      import("axios").then(({ default: axios }) => {
        axios
          .post(url, metadata, { withCredentials: true })
          .then(() => {
            this.notify("Table metadata updated", "Saved", "success");
          })
          .catch((error) => {
            this.notify(error, error.name, "error");
          })
          .finally(() => {
            this.toggleProgressSpinner(false);
          });
      });
    },
    copyTable(source, destination, doneHandler) {
      this.toggleProgressSpinner(true);
      const url = `${this.apiUrl}/task/table-copy?sync=${this.synchronousOperationTimeout}`;
      import("axios").then(({ default: axios }) => {
        axios
          .post(url, { source, destination }, { withCredentials: true })
          .then((response) => {
            if (response?.data?.status.toLowerCase() !== "finished") {
              this.toggleProgressSpinner(false);
              this.notify(
                "Operation will be processed asynchronously",
                "Taking too long",
                "success"
              );
              return;
            }
            this.notify(
              `Table ${source} was successfully copied to ${destination}`,
              "Table copied",
              "success"
            );
            const dest_parts = destination.split(".").splice(0);
            this.refreshStorage({
              kex: dest_parts[0],
              finishedHandler: () => {
                // this.toggleProgressSpinner(false);
                this.reloadStorageView(dest_parts[0], dest_parts[1]);
              },
            });
          })
          .catch((error) => {
            this.toggleProgressSpinner(false);
            this.notify(error, error.name, "error");
          })
          .finally(() => {
            if (doneHandler) doneHandler();
          });
      });
    },
    tableExists(kex, table, doneHandler) {
      const url = `${this.apiUrl}/storage/kex/${kex}/tables/${table}`;
      import("axios").then(({ default: axios }) => {
        axios
          .get(url, { withCredentials: true })
          .then(() => {
            doneHandler(true);
          })
          .catch(() => doneHandler(false));
      });
    },
    deleteTable(kex, table, doneHandler) {
      this.toggleProgressSpinner(true);
      const url = `${this.apiUrl}/storage/kex/${kex}/tables/${table}`;
      import("axios").then(({ default: axios }) => {
        axios
          .delete(url, { withCredentials: true })
          .then(() => {
            this.notify(
              `Table ${kex}.${table} was successfully deleted`,
              "Table deleted",
              "success"
            );
            this.refreshStorage({
              kex,
              finishedHandler: () => {
                this.toggleProgressSpinner(false);
                this.reloadStorageView(kex, null);
              },
            });
          })
          .catch((error) => {
            this.notify(error, error.name, "error");
            this.toggleProgressSpinner(false);
          })
          .finally(() => {
            if (doneHandler) doneHandler();
          });
      });
    },
    truncateTable(kex, table, doneHandler) {
      this.toggleProgressSpinner(true);
      const url = `${this.apiUrl}/storage/kex/${kex}/tables/${table}/truncate`;
      import("axios").then(({ default: axios }) => {
        axios
          .post(url, {}, { withCredentials: true })
          .then(() =>
            this.notify(
              `Table ${kex}.${table} was successfully truncated`,
              "Table truncated",
              "success"
            )
          )
          .catch((error) => this.notify(error, error.name, "error"))
          .finally(() => {
            this.toggleProgressSpinner(false);
            if (doneHandler) doneHandler();
          });
      });
    },
    deleteKex(kex) {
      this.toggleProgressSpinner(true);
      const url = `${this.apiUrl}/storage/kex/${kex}`;
      import("axios").then(({ default: axios }) => {
        axios
          .delete(url, { withCredentials: true })
          .then(() => {
            this.notify(
              `Kex ${kex} was successfully deleted.`,
              "Kex deleted",
              "success"
            );
            this.refreshStorage({
              root: true,
              finishedHandler: () => {
                this.toggleProgressSpinner(false);
                this.reloadStorageView();
              },
            });
          })
          .catch((error) => {
            this.notify(error, error.name, "error");
            this.toggleProgressSpinner(false);
          });
      });
    },
    refreshStorage({ root, kex, finishedHandler }) {
      if (root === undefined) root = false;
      if (kex === undefined) kex = null;
      let sync = 0;
      if (root || kex) sync = this.synchronousOperationTimeout;
      if (sync && !finishedHandler) {
        this.notify(
          "The request was not sent due to an error in the page.",
          "Error",
          "error"
        );
        throw new Error(
          "A synchronous response was requested, but no finishedHandler was provided"
        );
      }
      if (sync) this.toggleProgressSpinner(true);
      const url = `${this.apiUrl}/task/refresh-storage?sync=${sync}`;
      import("axios").then(({ default: axios }) => {
        axios
          .post(url, { root, kex }, { withCredentials: true })
          .then((response) => {
            if (sync && response.data?.status.toLowerCase() === "finished") {
              finishedHandler();
            } else {
              this.notify(response.data.status, "Task Created", "success");
            }
          })
          .catch((error) => {
            this.notify(error, error.name, "error");
          })
          .finally(() => this.toggleProgressSpinner(false));
      });
    },
  },
};
</script>

<style></style>
